(* Defen(estrator) - A Freesite Insertion and Management Tool       *)
(* by Travis Bemann and Eric Norige                                 *)
(*                                                                  *)
(* This program is free software; you can redistribute it and/or    *)
(* modify it under the terms of the GNU Lesser General Public       *)
(* License as published by the Free Software Foundation; either     *)
(* version 2 of the License, or (at your option) any later version. *)
(*                                                                  *)
(* This program is distributed in the hope that it will be useful,  *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of   *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    *)
(* GNU Lesser General Public License for more details.              *)

exception Error of string
exception Type_error

type t =
    Group of sexpr list
  | Name of string
  | String of string
  | Int of int
  | Float of float

val of_string : string -> t list
val to_string : t list -> string

val get_list : t -> t list
val get_string : t -> string
val get_int : t -> int
val get_float : t -> float
val expand_name : t -> string

val get_toplevel_name : t list -> string -> t
val get_name : t -> string -> t
val get_toplevel_name_mult : t list -> string -> t list
val get_name_mult : t -> string -> t list

val set_toplevel_name : t list -> string -> t -> t list
val set_name : t -> string -> t -> t
val set_toplevel_name_mult : t list -> string -> t list -> t list
val set_name_mult : t -> string -> t list -> t
